##
## Waveform server, run in waveform TCL console
## 
proc rx_command {} {
    global eofcnt cnt listen_socket com_sock
    
    set cnt [expr $cnt + 1]
    if {[eof $com_sock]} {
	if {$eofcnt == 0} {
	    puts "Client disconnected"; 
	    catch {close $listen_socket}
	    set eofcnt [expr $eofcnt + 1]
	    fileevent $com_sock readable ""
	    puts "Make sure to rerun the script for a new session"; 
	    
	}
    } else {
	# Read command
	set cmd [gets $com_sock]; 
	flush $com_sock	
	puts "Received from Telnet client: $cmd"
	#set retv [eval $cmd]
	catch {set retv [eval $cmd]} fid
	if {[info exists retv] == 0} {
	    set retv "N"
	}
	puts "info:WVSERVER $retv\n"
	puts $com_sock "WVSERVER $retv\n" 
	flush $com_sock
    }
    
    return
}

# Event handler for server 
proc accept {fd address port} {
    global client_online com_sock
    set com_sock $fd
    puts $fd "WVSERVER Server ack port $com_sock \n"; 
    flush $fd
    set client_online 1
    
    # create event when cmd is available from telnet
    fileevent $fd readable "rx_command"
    
    flush $fd
    puts "Client connected back\n"
}



proc read_addr {address} {
    # apply address signals...
    set rdata  [examine -value /tb_top_entity/rdata]
    set rdataBin [binary format B16 $rdata]
    set temp [binary scan $rdataBin H* rdataHex]
    puts "Address: $address Value: $rdataHex"
    return $rdataHex
}

# open the listen socket on port 2000
set serverPort 5100
set listen_socket [eval socket -server accept $serverPort]
puts "lsock $listen_socket\n"
set cnt 0
set eofcnt 0
# put server in non-blocking mode
fconfigure $listen_socket -blocking 0

# send server startup notice to stdout
puts "Simple Server running...\n"
puts "Listening on port $serverPort"; 
#flush stdout

# optional, uncomment if you wish to see the socket info
puts "socket configuration:\n[fconfigure $listen_socket]"; 
#flush stdout

# wait for telnet session to become active
vwait client_online
puts "Start remote terminal and issue commands";

